<!DOCTYPE html>
<html>
  <head>
    <link rel="stylesheet" type="text/css" href="https://pyscript.net/alpha/pyscript.css"/>
    <link rel="stylesheet" type="text/css" href="static/style.css"/>

    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>DRB Python Training</title>
    <script defer src="https://pyscript.net/alpha/pyscript.js"></script>
    <script src="static/check.js"></script>

    <title>
        <b>DRB Python Training</b>
    </title>
</head>

<py-env>
    - importlib-metadata
    - PyYaml
    - 'static/lib/drb-1.0.8+3.gd962af8.dirty-py3-none-any.whl'
</py-env>

  <body class="my_body">
    <h1 class="big_title">DrbLogicalNode</h1>

    <br />
    <br />

    <h2 class="chapter">Let's talk about drb logical Node</h2>

    <br />
    <br />

    <p>
      This node implements an in-memory logical node, these nodes are mutable DrbNode able to manage changes on its properties and also
      manage addition and removing of his children and attributes without
      performing any writing on the resource targeted by this node.
    </p>

    <br>
    <p class="code">def add_attribute(name: str, value: Optional[Any] = None, namespace_uri: Optional[str] = None) → None
    </p>
    <p>Adds an attribute to the current node.</p>

    <br>
    <p class="code">def update_attribute_value(name: str, value: Any, namespace_uri: Optional[str] = None) → None</p>
    <p>Updates value of an existing attribute on the current node.</p>
    
    <br>
    <p class="code">def remove_attribute(name: str, namespace_uri: Optional[str] = None) → None</p>
    <p>Removes the corresponding attribute.</p>
    
    <br>
    <p class="code">def append_child(node: drb.mutable_node.MutableNode) → None</p>
    <p>Appends a child at the end of the children list. The passed node is inserted in the list of children at the end of the current list.</p>
    
    <br>
    <p class="code">def insert_child(index: int, node: drb.mutable_node.MutableNode) → None</p>
    <p>Inserts a child at a given position. The passed node is inserted in the list of children at the given position The position is the expected index of the node after insertion. All the previous children from the aimed position to the end of the list are shift to the end of the new children list (i.e. their indices are shifted up of 1). If the given index is out of the children bounds and therefore less than zero and greater or equal to the current number of children,the operation raises an exception. An index equal to the current number of children is allowed and the operation is therefore equivalent to append_child(). If the node has been inserted within the children list, the next sibling indices are increased of one. In addition the associations between the inserted node and it previous and next siblings are updated (if any).</p>
    
    <br>
    <p class="code">def remove_child(index: int) → None</p>
    <p>Removes an existing child. The child at the given index is removed from the children list of the current node. The child is not modified by this operation. At the child point of view it keeps the same parent or any common association depending on the implementation.</p>
    
    <br>
    <p class="code">def replace_child(index: int, new_node: drb.mutable_node.MutableNode) → None</p>
    <p>Replaces a child of the current node. This operation replaces a child in the current children list by a new one The operation aborts when the index is out of bound (index < 0 || index > size). In case of error, the implementation has to restore the initial situation. It is therefore recommended for any implementation to check the consistency prior to perform the replacement.</p>


    <h2 class="chapter">Time to code</h2>

    <br />
    <br />
    <p>Using DrbLogicalNode please code the next tree of data: </p>


    <img src="static/images/examlpe.png">
    <br />
    <br />


    <py-box widths="2/3;1/3">
      <py-repl id="my-repl" std-out="output1" std-err="err-div"> </py-repl>
      <div id="output1" class="p-4"></div>
    </py-box>
    <input id="btn3" type="button" onclick = "clearBox('output1')" value="Clear Output"/>
    <input id="btn4" type="button" onclick = "show_soluce('# Code you diagrame here\nfrom drb.utils.logical_node import DrbLogicalNode\n# Parent\nlogical_node = DrbLogicalNode(source=\'logical_node\', parent=None, namespace_uri=\'Wizard\')\n\n# Childrens\naragorn = DrbLogicalNode(source=\'Aragorn\', parent=logical_node, namespace_uri=\'Human\', value=3)\nfirst = DrbLogicalNode(source=\'Legolas\', parent=logical_node, namespace_uri=\'Elf\', value=4)\nfirst.add_attribute(\'Weapon\', \'Bow\')\nsecond = DrbLogicalNode(source=\'Gimli\', parent=logical_node, namespace_uri=\'Dwarf\', value=4)\nsecond.add_attribute(\'Weapon\', \'Axe\')\nboromir = DrbLogicalNode(source=\'Boromir\', parent=logical_node, namespace_uri=\'Human\', value=1)\n\n# Connect nodes together\naragorn.append_child(first)\naragorn.append_child(second)\nlogical_node.append_child(aragorn)\nlogical_node.append_child(boromir)\n')" value="Show Soluce"/>

  <br />
  <br />
    <p>
      If you build your node correctly all the next cell should be executed with no problem.
    </p>
  <br />
    <py-repl>
logical_node.name 
    </py-repl>

    <py-repl>
[e.namespace_uri for e in logical_node.children]
    </py-repl>

    <py-repl>
logical_node.has_child(namespace='Human')
    </py-repl>

    <py-repl>
(None, 'Human') in logical_node     
    </py-repl>

    <py-repl>
('age', None) in logical_node['Aragorn']['Legolas'].attributes  
    </py-repl>

    <py-repl>
('Weapon', None) in logical_node['Aragorn']['Legolas'].attributes  
    </py-repl>

    <py-repl>
logical_node[0][0].value 
    
    </py-repl>

    <py-repl>
logical_node[0][1].has_child()  
    </py-repl>

    <py-repl>
logical_node['Aragorn'].has_child(namespace='Dwarf')
    </py-repl>

    <py-repl>
len(logical_node)  
    </py-repl>

    <footer>
      <p><A HREF="drivers.html">Drivers & Factory</A></p>
      <p><a href="/">Home Page</a></p>

    </footer>
    <footer id="err-div" class="bg-red-700 text-white text-center border-t-4 border-green-500 fixed inset-x-0 bottom-0 p-4 hidden"/>

  </body>
</html>
